<script lang="ts">
  import type { SessionComposition } from "$lib/local/types/sessionComposition.type";
  import PresetItem from "./PresetItem.svelte";
  import { userLocalPreferences } from "$lib/local/stores/local.store";
  import Button from "$lib/tidy/elements/button/Button.svelte";
  import { PointronEventEnum } from "$lib/local/types/pointronEvent.enum";
  import { runAction } from "$lib/tidy/utils/utils";
  export let parentBackgroundIndex = 1;
  export let isExpandedVariant: boolean = true;
  let selectedPresetIndex: number = -1;
  let selectedPreset: SessionComposition;
  function presetClickHandler(event: any) {
    selectedPreset = event.detail.preset;
    selectedPresetIndex = $userLocalPreferences.presets.indexOf(
      selectedPreset!
    );
    showEditor(selectedPreset.id);
  }
  function onAddNewClicked() {
    selectedPresetIndex = -1;
    showEditor();
  }
  function showEditor(id: string = "") {
    runAction(PointronEventEnum.EDIT_PRESET, { id });
  }
</script>

{#each $userLocalPreferences.presets as preset, index}
  <PresetItem
    {preset}
    {parentBackgroundIndex}
    isInEditMode={true}
    {isExpandedVariant}
    isActive={selectedPresetIndex === index}
    on:click={presetClickHandler}
  />
{/each}
<div class={isExpandedVariant ? "pb-40" : ""}>
  <Button
    {parentBackgroundIndex}
    on:click={onAddNewClicked}
    width={isExpandedVariant ? "w-full max-w-md" : "w-28"}
    label="add new"
    icon="plus"
  />
</div>
